## visad.util
Interface CmdlineConsumer

All Known Implementing Classes:
  CmdlineGenericConsumer, NuView, TestDownload

public interface CmdlineConsumer

Method Summary
`int` `checkKeyword(String mainName, int thisArg, String[] args)` Handle subclass-specific command line options and their arguments.

`int`

`checkOption(String mainName, char ch, String arg)`
Handle subclass-specific command line options and their arguments.
If `-abc -d efg -h -1 -i` is specified, this method will be called a maximum of 5 times: `checkOption(mainName, 'a', "bc");` `checkOption(mainName, 'd', "efg");` `checkOption(mainName, 'h', "-1");` `checkOption(mainName, '1', "-i");` `checkOption(mainName, 'i', null);`
Note that either of the last two method calls may not happen if the preceeding method call claims to have used the following argument (by returning `2`.
For example, if the third call (where `ch` is set to `'h'`) returns `0` or `1`, the next call will contain `'1'` and `"-i"`.

`boolean` `finalizeArgs(String mainName)` Validate arguments after argument parsing has finished. This is useful for verifying that all required keywords and options have been specified, that options don't conflict with one another, etc.
`void` `initializeArgs()` Method used to initialize any instance variables which may be changed by a cmdline option. This is needed when arguments are processed inside the constructor.
`String` `keywordUsage()` A short string included in the usage message to indicate valid keywords. An example might be `"[username] [password]"`.
`String` `optionUsage()` A short string included in the usage message to indicate valid options.

Method Detail

### initializeArgs

    public void initializeArgs()

  Method used to initialize any instance variables which may be changed by a cmdline option.
  This is needed when arguments are processed inside the constructor. If the first line in the constructor in a class which extends this class is `super(args)`, `CmdlineParser` will be run before any instance variables for the extending class are initialized.
  To ensure all instance variables are properly initialized, place the initialization code in the initializeArgs() method.

### checkOption

    public int checkOption(String mainName,
                           char ch,
                           String arg)

  Handle subclass-specific command line options and their arguments.
  If `-abc -d efg -h -1 -i` is specified, this method will be called a maximum of 5 times:
  - `checkOption(mainName, 'a', "bc");`
  - `checkOption(mainName, 'd', "efg");`
  - `checkOption(mainName, 'h', "-1");`
  - `checkOption(mainName, '1', "-i");`
  - `checkOption(mainName, 'i', null);`
  Note that either of the last two method calls may not happen if the preceeding method call claims to have used the following argument (by returning `2`.
  For example, if the third call (where `ch` is set to `'h'`) returns `0` or `1`, the next call will contain `'1'` and `"-i"`. If, however, the third call returns `2`, the next call will contain `'i'` and `null`.

  Parameters:
    `mainName` - The name of the main class (useful for error messages.)
    `ch` - Option character. If `-a` is specified on the command line, `'a'` would be passed to this method.)
    `arg` - The argument associated with this option.
  Returns:
    less than `0` to indicate an error
    `0` to indicate that this option is not used by this class
    `1` to indicate that only the option was used
    `2` or greater to indicate that both the option and the argument were used

### optionUsage

    public String optionUsage()

  A short string included in the usage message to indicate valid options. An example might be `"[-t type]"`.

  Returns:
    A very terse description string.

### checkKeyword

    public int checkKeyword(String mainName,
                            int thisArg,
                            String[] args)

  Handle subclass-specific command line options and their arguments.

  Parameters:
    `mainName` - The name of the main class (useful for error messages.)
    `thisArg` - The index of the current keyword.
    `args` - The full list of arguments.
  Returns:
    less than `0` to indicate an error
    `0` to indicate that this argument is not used by this class
    `1 or more` to indicate the number of arguments used

### keywordUsage

    public String keywordUsage()

  A short string included in the usage message to indicate valid keywords.
  An example might be `"[username] [password]"`.

  Returns:
    A very terse description string.

### finalizeArgs

    public boolean finalizeArgs(String mainName)

  Validate arguments after argument parsing has finished.
  This is useful for verifying that all required keywords and options have been specified, that options don't conflict with one another, etc.

  Parameters:
    `mainName` - The name of the main class (useful for error messages.)
  Returns:
    `true` if everything is correct, `false` if there is a problem.